package com.lambdaworks.redis;

import com.lambdaworks.redis.pubsub.RedisPubSubAdapter;
import com.lambdaworks.redis.pubsub.RedisPubSubConnection;

/**
 * Created with IntelliJ IDEA.
 * User: will
 * Date: 5/24/12
 * Time: 2:06 PM
 * To change this template use File | Settings | File Templates.
 */
public class PubSubBug {
    public static void main(String[] args) throws Exception {
        RedisClient client = new RedisClient("localhost");

        final RedisPubSubConnection<String, String> pubsub = client.connectPubSub();
        final RedisPubSubConnection<String, String> redis = client.connectPubSub();
        final long total = 1000;

        System.out.printf("pubsub %s\n", pubsub);
        System.out.printf("publisher %s\n", redis);

        pubsub.subscribe("test");
        pubsub.addListener(new RedisPubSubAdapter<String, String>() {
            long counter = 0;

            @Override
            public void message(String channel, String message) {
                String expected = "foo " + counter++;
                if (!channel.equals("test") || !message.equals(expected)) {
                    System.out.printf("expected %s, got %s on channel %s\n", expected, message, channel);
                }
                if (counter == total) {
                    System.out.printf("done!");
                    pubsub.close();
                    redis.close();
                    System.exit(0);
                }
            }
        });

        for (int i = 0; i < total; i++) {
            redis.publish("test", "foo " + i);
        }
    }
}
